package clusterer;

import bico.Bico;
import bico.BicoPoint;
import measure.Measure;
import utils.Triple;

import java.util.ArrayList;

/**
 * Created by Eike on 08.03.2015.
 *
 DBSCAN(D, eps, MinPts)
 C = 0
 for each unvisited point P in dataset D
 mark P as visited
 N = D.regionQuery(P, eps)
 if sizeof(N) < MinPts
 mark P as NOISE
 else
 C = next cluster
 expandCluster(P, N, C, eps, MinPts)

 expandCluster(P, N, C, eps, MinPts)
     add P to cluster C
     for each point P' in N
        if P' is not visited
            mark P' as visited
        N' = D.regionQuery(P', eps)
        if sizeof(N') >= MinPts
            N = N joined with N'
        if P' is not yet member of any cluster
            add P' to cluster C
 */
public class BicoDBScan {
    private double eps;
    private  int minPts;
    private ArrayList<Triple<Integer,Boolean,BicoPoint>> input;

    public BicoDBScan(double eps, int minPts, ArrayList<BicoPoint> input)
    {
        this.eps = eps;
        this.minPts = minPts;
        this.input = new ArrayList<Triple<Integer, Boolean, BicoPoint>>();
        for(BicoPoint p : input) {
            this.input.add(new Triple<Integer, Boolean, BicoPoint>(-1,false,p));
        }
    }
    /*
    DBSCAN(D, eps, MinPts)
         C = 0
         for each unvisited point P in dataset D
             mark P as visited
             N = D.regionQuery(P, eps)
             if sizeof(N) < MinPts
                mark P as NOISE
             else
                C = next cluster
                expandCluster(P, N, C, eps, MinPts)
     */
    public void run()
    {
        int c = 0;
        for(Triple<Integer,Boolean,BicoPoint> tr : input)
        {
            if(!tr.second())
            {
                tr.setSecond(true);
                ArrayList<BicoPoint> neighours = getNeighours(tr.third(), eps);
                if(neighours.size() < minPts)
                {

                } else {
                    c++;
                }
            }
        }
    }

    public ArrayList<BicoPoint> getNeighours(BicoPoint p, double eps)
    {
        ArrayList<BicoPoint> ret = new ArrayList<BicoPoint>();
        for(Triple<Integer,Boolean,BicoPoint> tr : input)
        {
            if(Measure.Instance().calcDissimilarity(tr.third(),p) < eps)
                ret.add(tr.third());
        }
        return ret;
    }
}
