package clusterer;

import bico.BicoPoint;
import org.apache.commons.math3.ml.clustering.Cluster;
import org.apache.commons.math3.ml.clustering.DBSCANClusterer;
import org.apache.commons.math3.ml.distance.DistanceMeasure;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by eike on 06.12.14.
 */
public class DBScan {
    private DBSCANClusterer dbscan;

    public DBScan(final double eps, final int minPts) {
        dbscan = new DBSCANClusterer(eps, minPts);
    }

    public DBScan(final double eps, final int minPts, DistanceMeasure measure)
    {
        dbscan = new DBSCANClusterer(eps, minPts, measure);
    }

    public List<Cluster<BicoPoint>> getCluster(ArrayList<BicoPoint> list)
    {
        return dbscan.cluster(list);
    }
}
