package clusterer;

import org.apache.commons.math3.ml.clustering.CentroidCluster;
import org.apache.commons.math3.ml.clustering.Clusterable;
import org.apache.commons.math3.ml.clustering.KMeansPlusPlusClusterer;
import org.apache.commons.math3.ml.distance.DistanceMeasure;
import org.apache.commons.math3.random.RandomGenerator;

import java.util.ArrayList;
import java.util.List;

public class KMeansPP<T extends Clusterable> {

    private KMeansPlusPlusClusterer<T> kmeans;
    private int k;
    private int maxIt;
    private DistanceMeasure measure;
    private RandomGenerator rnd;

    public KMeansPP(final int k, final int maxIt)
    {
        this.k = k;
        this.maxIt = maxIt;
        kmeans = new KMeansPlusPlusClusterer<T>(k, maxIt);
    }

    public KMeansPP(final int k, final int maxIt, DistanceMeasure measure)
    {
        this(k, maxIt);
        this.measure = measure;
    }

    public KMeansPP(final int k, final int maxIt, DistanceMeasure measure, org.apache.commons.math3.random.RandomGenerator rnd)
    {
        this(k, maxIt, measure);
        this.rnd = rnd;
    }


    public List<CentroidCluster<T>> cluster(ArrayList<T> points) {
        return kmeans.cluster(points);
    }
}