package clusterer;

import bico.BicoPoint;
import measure.Measure;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;

/**
 * Created by eike on 01.02.15.
 */
public class MacQueen {
    private ArrayList<BicoPoint> points;



    public MacQueen()
    {
        points = new ArrayList<BicoPoint>();
    }

    public void add(BicoPoint point)
    {
        points.add(point);
    }

    public ArrayList<BicoPoint> cluster(final int k)
    {
        ArrayList<BicoPoint> ret = new ArrayList<BicoPoint>();

        HashMap<Integer, ArrayList<BicoPoint>> centers = new HashMap<Integer, ArrayList<BicoPoint>>();

        for(BicoPoint p : points)
        {
            if(centers.size() < k)
            {
                centers.put(centers.size(), new ArrayList<BicoPoint>(Arrays.asList(p)));
            } else {
                Double dist = -1.0;
                int center = -1;
                for(Integer i : centers.keySet())
                {
                    Double tmp = Math.sqrt(Measure.Instance().calcDissimilarity(p, getCenter(centers.get(i))));
                    if(dist == -1.0 || tmp < dist)
                    {
                        dist = tmp;
                        center = i;
                    }
                }
                centers.get(center).add(p);
            }
        }

        for(Integer i : centers.keySet())
        {
            ret.add(getCenter(centers.get(i)));
        }

        return ret;
    }

    public BicoPoint getCenter(ArrayList<BicoPoint> pList)
    {
        BicoPoint eSum = null;
        for(BicoPoint p : pList)
        {
            if(eSum == null)
            {
                eSum = new BicoPoint(p);
            } else {
                eSum.Add(p);
            }
        }
        return eSum.div(pList.size());
    }
}
