package nearest;

import bico.BicoPoint;
import bico.CoresetFeature;
import measure.Measure;
import utils.BicoUtils;

import java.util.ArrayList;
import java.util.HashMap;

/**
 * Created by Eike on 14.03.2015.
 */
public class Hashing implements INearest {

    private HashMap<Integer,ArrayList<CoresetFeature>> Buckets;
    private double[] widths;
    private int[] counts;
    //private double offSetsPlus[];
    //private double offSetsMinus[];
    private int Cellsize;
    private SimpleNearesetNeighbour simple;
    private boolean isInit = false;

    @Override
    public void Init() {
        if(!isInit) {
            widths = new double[BicoUtils.dimensions];
            counts = new int[BicoUtils.dimensions];
            simple = new SimpleNearesetNeighbour();
            isInit = true;
        }
    }

    @Override
    public void InitStructure(ArrayList<BicoPoint> pList) {
        if(pList.size() > 0) {

            //offSetsPlus = new double[pList.get(0).Dimensions()];
            //offSetsMinus = new double[pList.get(0).Dimensions()];


            /*for(int i = 0; i < pList.get(0).Dimensions(); ++i)
            {
                offSetsMinus[i] = (widths[i] / Cellsize) - (widths[i] / Cellsize) * 0.1;
                offSetsPlus[i] = (widths[i] / Cellsize) + (widths[i] / Cellsize) * 0.1;
            }*/

            Cellsize = (int)Math.ceil(pList.size() * 0.2);
            Buckets = new HashMap<Integer, ArrayList<CoresetFeature>>();

            for(int i=0; i < counts.length; ++i)
            {
                counts[i] = (int) Math.ceil(widths[i] * 100.0 / (widths[i] * 0.2));
            }
        }
    }

    private int getBucketId(BicoPoint p)
    {
        int hashId = 0;

        for(int i = 0; i < p.Dimensions(); ++i)
        {
            hashId += (int)Math.floor(p.getEntry(i) / (counts[i] == 0 ? 1 : counts[i]));
        }

        return hashId;
    }

    @Override
    public void Rebuild(CoresetFeature cf) {
        //Buckets.clear();
        /*for(CoresetFeature cf2 : cf.children)
        {
            int id = getBucketId(cf2.RefPoint);
            if(!Buckets.containsKey(id))
                Buckets.put(id, new ArrayList<CoresetFeature>());
            Buckets.get(id).add(cf2);
        }*/
    }

    @Override
    public void Collect(final BicoPoint p, int level) {
        //int id = getBucketId(p);
        //if(!Buckets.containsKey(id))
          //  Buckets.put(id, new ArrayList<CoresetFeature>());
        //Buckets.get(id).add(p);
    }

    @Override
     public void Clear()
    {
        Buckets.clear();
    }

    @Override
    public void Training(final BicoPoint p, final BicoPoint p2)
    {

        if(p2.equals(p))
            return;
        for(int i = 0; i < p2.Dimensions(); ++i)
        {
            if(Math.abs(p2.getEntry(i) - p.getEntry(i)) > widths[i])
                widths[i] = Math.abs(p2.getEntry(i) - p.getEntry(i));
        }

    }

    @Override
    public void Collect(final CoresetFeature cf, int level) {
        if(level == 1) {
            int id = getBucketId(cf.RefPoint);
            if (!Buckets.containsKey(id))
                Buckets.put(id, new ArrayList<CoresetFeature>());
            Buckets.get(id).add(cf);
        }
    }

    @Override
    public CoresetFeature getNearest(CoresetFeature p, BicoPoint p2, int level) {
        if(level == 1) {
            int id = getBucketId(p2);
            CoresetFeature retCf = null;
            if(Buckets.containsKey(id))
            {
                double minDist = -1.0;

                for(CoresetFeature cf : Buckets.get(id))
                {
                    double tmpDist = Measure.Instance().calcDissimilarity(cf, p2);
                    if(minDist == -1.0 || tmpDist < minDist)
                    {
                        minDist = tmpDist;
                        retCf = cf;
                    }
                }
            }
            return retCf;
        } else
            return simple.getNearest(p, p2, level);
    }

    @Override
    public CoresetFeature getNearest(CoresetFeature cf, CoresetFeature child, int level) {
        return getNearest(cf, child.RefPoint, level);
    }
}
