package utils;

import bico.BicoPoint;
import bico.CoresetFeature;
import measure.Measure;
import org.apache.commons.math3.ml.clustering.CentroidCluster;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

/**
 * Created by eike on 22.11.14.
 */
public class BicoUtils {

    public static double Threshold;
    private static double Threshold_old;
    public static HashMap<Integer,Double> radii;

    public static Double epsilon = null;

    public static void Init()
    {
        radii = new HashMap<Integer, Double>();
    }

    public static void Reset() { radii.clear(); Threshold = 0.0; Threshold_old = -1.0; }

    public static int dimensions = -1;

    public static double GetRadius(int level)
    {
        if(Threshold_old != Threshold)
        {
            Threshold_old = Threshold;
            radii.clear();
        }
        if(!radii.containsKey(level))
            radii.put(level, Threshold / (double)(1 << (3 + level)));

        //return Math.sqrt(2 * Threshold / (8 * Math.pow(2, level)));
        //return Threshold / (double)(1 << (3 + level));

        return radii.get(level);
    }

    public static double varianz(List<CentroidCluster<BicoPoint>> centers) {
        double ret = 0.0;
        for(int i = 0; i < centers.size(); ++i)
        {
            for(int j = 0; j < centers.get(i).getPoints().size(); ++j)
            {
                ret += Measure.Instance().calcDissimilarity(centers.get(i).getPoints().get(j), new BicoPoint(centers.get(i).getCenter().getPoint()));
            }
        }
        return ret;
    }

    public static double varianzCf(List<CentroidCluster<CoresetFeature>> centers) {
        double ret = 0.0;
        for(int i = 0; i < centers.size(); ++i)
        {
            for(int j = 0; j < centers.get(i).getPoints().size(); ++j)
            {
                ret += centers.get(i).getPoints().get(j).kMeansCost(new BicoPoint(centers.get(i).getCenter().getPoint()));
            }
        }
        return ret;
    }

    public static double varianz(Pair<Double[][], Triple<Double, Double[], Integer>[]> points)
    {
        double ret = 0.0;

        HashMap<Integer, ArrayList<Pair<Double[], Double>>> centers = new HashMap<Integer, ArrayList<Pair<Double[], Double>>>();

        for(Triple<Double, Double[], Integer> triple : points.second())
        {
            if(!centers.containsKey(triple.third()))
                centers.put(triple.third(), new ArrayList<Pair<Double[], Double>>());
            centers.get(triple.third()).add(new Pair<Double[], Double>(triple.second(), triple.first()));
        }

        /*for(int i = 0; i < centers.keySet().size(); ++i)
        {
            Double[] tmp = getCenter(centers.get(i));
            for(int j = 0; j < points.first()[i].length; ++j)
            {
                System.out.print(tmp[j].toString() + " ");
            }
            System.out.println();
            for(int j = 0; j < points.first()[i].length; ++j)
            {
                System.out.print(points.first()[i][j].toString() + " ");
            }
            System.out.println();
        }*/

        for(int k = 0; k < centers.keySet().size(); ++k)
        {
            Double[] center = getCenter(centers.get(k));
            for(int i = 0; i < centers.get(k).size(); ++i)
            {
                ret += centers.get(k).get(i).second() * Measure.Instance().squaredDistance(center, centers.get(k).get(i).first());
            }
        }

        /*for(int k = 0; k < points.first().length; ++k)
        {

            for(int i = 0; i < points.second().length; ++i)
            {
                Double[] center = points.first()[points.second()[i].third()];
                Double[] point = points.second()[i].second();
                ret += points.second()[i].first() * Measure.Instance().squaredDistance(center, point);
            }
        }*/

        return ret;
    }

    public static Double[] getCenter(ArrayList<Pair<Double[], Double>> points)
    {
        Double[] ret = new Double[points.get(0).first().length];
        for(int i=0; i < ret.length; ++i)
        {
            ret[i] = 0.0;
        }
        for(Pair<Double[], Double> point : points)
        {
            for(int i=0; i < ret.length; ++i)
            {
                ret[i] += point.first()[i];
            }
        }
        for(int i=0; i < ret.length; ++i)
        {
            ret[i] /= points.size();
        }
        return ret;
    }

    public static double varCfWithOri(List<CentroidCluster<BicoPoint>> centers, List<CentroidCluster<CoresetFeature>> centersCf)
    {
        double ret = 0.0;
        for(CentroidCluster<CoresetFeature> p : centersCf)
        {

        }
        return ret;
    }

    /*public static double ICC(List<CentroidCluster<BicoPoint>> centers)
    {
        ArrayList<BicoPoint> tmpCenters = new ArrayList<BicoPoint>();
        for(CentroidCluster<BicoPoint> c : centers)
            tmpCenters.add(new BicoPoint(c.getCenter().getPoint()));

        double intra = IntraCluster(tmpCenters);
        double inter = InterCluster()
    }*/

    public static double InterCluster(BicoPoint center, List<BicoPoint> points)
    {
        double ret = 0.0;

        for(BicoPoint p : points)
        {
            ret += Measure.Instance().calcDissimilarity(p, center);
        }

        return ret;
    }

    public static double IntraCluster(List<BicoPoint> centers)
    {
        double ret = 0.0;

        for(BicoPoint p : centers)
        {
            for(BicoPoint p2 : centers) {
                if(p.equals(p2))
                    continue;
                ret += Measure.Instance().calcDissimilarity(p, p2);
            }
        }

        return ret;
    }
}
