package utils;

/**
 * Created by eike on 30.12.14.
 */
public class Random {
    private static java.util.Random fRandom = new java.util.Random();

    public static double rand(double high, double low)
    {
        return Math.random() * (high - low) + low;
    }
    public static int getInt(int start, int end)
    {
        if(start > end)
            throw new IllegalArgumentException("Start cannot exceed End.");
        return fRandom.nextInt(end) + start;
    }

    public static double getDouble(double start, double end)
    {
        if(start > end)
            throw new IllegalArgumentException("Start cannot exceed End.");
        return start + (end - start) * fRandom.nextDouble();
    }

    public static double getGaussian(double aMean, double aVariance){
        return aMean + fRandom.nextGaussian() * aVariance;
    }
}
